﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ZoneMover : MonoBehaviour
{
	private const float SPEED = 0.2f;

	private bool isMoving = false;
	private float accum = 0.0f;
	private bool flipAccum = false;
	// Controls whether accumulator is increasing or decreasing.
	private Vector3 startPos;
	private Vector3 endPos;

	// Use this for initialization
	void Start ()
	{
		float y = transform.position.y;
		float z = transform.position.z;
		startPos = new Vector3 (-4.0f, y, z);
		endPos = new Vector3 (4.0f, y, z);
	}
	
	// Update is called once per frame
	void Update ()
	{
		if (!isMoving) {
			return;
		}

		accum = Mathf.Clamp (accum + Time.deltaTime * AccumSign () * SPEED, 0.0f, 1.0f);
		if (accum == 0.0f || accum == 1.0f) {
			flipAccum = !flipAccum;
		}

		transform.position = Vector3.Lerp (startPos, endPos, accum);
	}

	float AccumSign ()
	{
		return flipAccum ? -1.0f : 1.0f;
	}

	public void SetMoving (bool isMoving)
	{
		this.isMoving = isMoving;
	}
}
